﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Text;
using System.Web.Script.Serialization;
using System.Net.Http;
using System.Net;
using System.IO;

namespace GridView_WebAPI_HttpWebRequest_HttpClient
{
    public partial class Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!this.IsPostBack)
            {
                this.PopulateGridView();
            }
        }

        protected void Search(object sender, EventArgs e)
        {
            this.PopulateGridView();
        }

        private void PopulateGridView()
        {
            string apiUrl = "http://localhost:26404/api/CustomerAPI";
            var input = new
            {
                Name = txtName.Text.Trim(),
            };
            string inputJson = (new JavaScriptSerializer()).Serialize(input);
            HttpWebRequest httpRequest = (HttpWebRequest)WebRequest.Create(new Uri(apiUrl + "/GetCustomers"));
            httpRequest.ContentType = "application/json";
            httpRequest.Method = "POST";

            byte[] bytes = Encoding.UTF8.GetBytes(inputJson);
            using (Stream stream = httpRequest.GetRequestStream())
            {
                stream.Write(bytes, 0, bytes.Length);
                stream.Close();
            }

            using (HttpWebResponse httpResponse = (HttpWebResponse)httpRequest.GetResponse())
            {
                using (Stream stream = httpResponse.GetResponseStream())
                {
                    string json = (new StreamReader(stream)).ReadToEnd();
                    gvCustomers.DataSource = (new JavaScriptSerializer()).Deserialize<List<Customer>>(json);
                    gvCustomers.DataBind();
                }
            }
        }

        public class Customer
        {
            public string CustomerID { get; set; }
            public string ContactName { get; set; }
            public string City { get; set; }
        }
    }
}